﻿Public Class Form1
    ' Define a delegate type named FofXY.
    Private Delegate Function FofXY(ByVal x As Single, ByVal y As Single) As Single

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.Cursor = Cursors.WaitCursor

        ' Make the Bitmap.
        Dim bm As New Bitmap(picGraph.ClientSize.Width, picGraph.ClientSize.Height)
        Using gr As Graphics = Graphics.FromImage(bm)
            ' Clear.
            gr.Clear(Color.White)
            gr.ScaleTransform(24.0F, -24.0F, System.Drawing.Drawing2D.MatrixOrder.Append)
            gr.TranslateTransform(bm.Width * 0.5F, bm.Height * 0.5F, _
                System.Drawing.Drawing2D.MatrixOrder.Append)

            ' Draw axes.
            Using axis_pen As New Pen(Color.LightGray, 0)
                gr.DrawLine(axis_pen, -6, 0, 6, 0)
                gr.DrawLine(axis_pen, 0, -6, 0, 6)
                For i As Integer = -6 To 6
                    gr.DrawLine(axis_pen, i, -0.1F, i, 0.1F)
                    gr.DrawLine(axis_pen, -0.1F, i, 0.1F, i)
                Next i
            End Using

            ' Graph the equation.
            Dim dx As Single = 2.0F / bm.Width
            Dim dy As Single = 2.0F / bm.Height
            PlotFunction(gr, AddressOf F1, -6, -6, 6, 6, dx, dy)
            PlotFunction(gr, AddressOf F2, -6, -6, 6, 6, dx, dy)
        End Using

        ' Display the result.
        picGraph.Image = bm
        Me.Cursor = Cursors.Default
    End Sub

    ' Plot a function.
    Private Sub PlotFunction(ByVal gr As Graphics, ByVal func As FofXY, _
     ByVal xmin As Single, ByVal ymin As Single, ByVal xmax As Single, ByVal ymax As Single, _
     ByVal dx As Single, ByVal dy As Single)
        ' Plot the function.
        Using thin_pen As New Pen(Color.Black, 0)
            ' Horizontal comparisons.
            For x As Single = xmin To xmax Step dx
                Dim last_y As Single = func(x, ymin)
                For y As Single = ymin + dy To ymax Step dy
                    Dim next_y As Single = func(x, y)
                    If ( _
                        ((last_y <= 0.0F) AndAlso (next_y >= 0.0F)) OrElse _
                        ((last_y >= 0.0F) AndAlso (next_y <= 0.0F)) _
                       ) _
                   Then
                        ' Plot this point.
                        gr.DrawLine(thin_pen, x, y - dy, x, y)
                    End If
                    last_y = next_y
                Next y
            Next x ' Horizontal comparisons.

            ' Vertical comparisons.
            For y As Single = ymin + dy To ymax Step dy
                Dim last_x As Single = func(xmin, y)
                For x As Single = xmin + dx To xmax Step dx
                    Dim next_x As Single = func(x, y)
                    If ( _
                        ((last_x <= 0.0F) AndAlso (next_x >= 0.0F)) OrElse _
                        ((last_x >= 0.0F) AndAlso (next_x <= 0.0F)) _
                       ) _
                    Then
                        ' Plot this point.
                        gr.DrawLine(thin_pen, x - dx, y, x, y)
                    End If
                    last_x = next_x
                Next x
            Next y ' Vertical comparisons.
        End Using
    End Sub

    ' Calculate:
    '   [x^2 + y^2 - 225] *
    '   [x^2 + y^2 - 10000] *
    '   [(x - 45)^2 + (y - 35)^2 - 225] *
    '   [(x + 45)^2 + (y - 35)^2 - 225]
    Private Function F1(ByVal x As Single, ByVal y As Single) As Single
        ' Flip y to make the image appear rightside up.
        Return _
            (x * x + y * y - 25.0F) * _
            (x * x + y * y - 1.0F) * _
            ((x - 2.5F) * (x - 2.5F) + (y - 2.0F) * (y - 2.0F) - 1.0F) * _
            ((x + 2.5F) * (x + 2.5F) + (y - 2.0F) * (y - 2.0F) - 1.0F)
    End Function

    ' Calculate:
    '   y + Sqrt(16 - x^2)
    Private Function F2(ByVal x As Single, ByVal y As Single) As Single
        Return CSng(y + Math.Sqrt(12.25F - x * x))
    End Function
End Class
